; https://forum.bricsys.com/discussion/35659/constant-slope-of-curve-path-like-in-blender

(defun c:SlopeSpline ( / cnt doc enm hgt i len new obj pt ptLst)
  (setq doc (vla-get-activedocument (vlax-get-acad-object)))
  (vla-endundomark doc)
  (vla-startundomark doc)
  (if
    (and
      (or
        (= 1 (getvar 'worlducs))
        (prompt "\nError: WCS required ")
      )
      (setq enm (car (entsel)))
      (setq obj (vlax-ename->vla-object enm))
      (= "AcDbSpline" (vla-get-objectname obj))
      (or
        (equal '(0.0 0.0 1.0) (vle-entget 210 enm) 1e-8)
        (prompt "\nError: spline not parallel to XY plane ")
      )
      (setq hgt (getdist "\nTotal height: "))
      (setq cnt (getint "\nNumber of fitpoints: "))
    )
    (progn
      (setq len (vle-curve-getperimeter obj)) ; Hor. length.
      (setq i cnt)
      (repeat cnt
        (setq pt
          (cond
            ((vlax-curve-getpointatdist obj (* i (/ len cnt))))
            ((vlax-curve-getendpoint obj)) ; Just in case.
          )
        )
        (setq ptLst (cons (list (car pt) (cadr pt) (* i (/ hgt cnt))) ptLst))
        (setq i (1- i))
      )
      (setq new
        (vla-addspline
          (vla-get-modelspace doc)
          (apply 'append ptLst)
          '(0.0 0.0 0.0)
          '(0.0 0.0 0.0)
        )
      )
    )
  )
  (vla-endundomark doc)
  (princ)
)
